// OptionsTreeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "OptionsTree.h"
#include "OptionsTreeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionsTreeDlg dialog

COptionsTreeDlg::COptionsTreeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COptionsTreeDlg::IDD, pParent)
{
  m_bDlgCreated = false;

	//{{AFX_DATA_INIT(COptionsTreeDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void COptionsTreeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionsTreeDlg)
	DDX_Control(pDX, IDC_TREE, m_Tree);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(COptionsTreeDlg, CDialog)
	//{{AFX_MSG_MAP(COptionsTreeDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_NOTIFY(TVN_SELCHANGING, IDC_TREE, OnSelchangingTree)
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE, OnSelchangedTree)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionsTreeDlg message handlers

BOOL COptionsTreeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
// --------------------------------------------------------------------------

  CImageList* pInfoImages = new CImageList;
  pInfoImages->Create(16, 16, ILC_COLOR8 | ILC_MASK, 2, 0);
  pInfoImages->Add(AfxGetApp()->LoadIcon(IDI_ICON1));
  pInfoImages->Add(AfxGetApp()->LoadIcon(IDI_ICON2));
  m_Tree.SetImageList(pInfoImages, TVSIL_NORMAL);

  HTREEITEM hTreeItem1;
  HTREEITEM hTreeItem2;

  hTreeItem1 = m_Tree.InsertItem("Root Item 1", 0, 1, TVI_ROOT, TVI_LAST);
  m_Tree.SetItemData(hTreeItem1, (DWORD)&m_OptionsRoot1);

  hTreeItem2 = m_Tree.InsertItem("Tree Item 1", 0, 1, hTreeItem1, TVI_LAST);
  m_Tree.SetItemData(hTreeItem2, (DWORD)&m_OptionsTree1);

  hTreeItem1 = m_Tree.InsertItem("Root Item 2", 0, 1, TVI_ROOT, TVI_LAST);
  m_Tree.SetItemData(hTreeItem1, (DWORD)&m_OptionsRoot2);

  m_OptionsRoot1.Create(IDD_OPTIONS_ROOT1, this);
  m_OptionsTree1.Create(IDD_OPTIONS_TREE1, this);

  m_OptionsRoot2.Create(IDD_OPTIONS_ROOT2, this);

  CRect rcDlgs;
  GetDlgItem(IDC_DLG_AREA)->GetWindowRect(rcDlgs);
  ScreenToClient(rcDlgs);
  rcDlgs.top += 12;
  rcDlgs.bottom -= 5;
  rcDlgs.left += 5;
  rcDlgs.right -= 5;
  m_OptionsRoot1.MoveWindow(rcDlgs);  
  m_OptionsTree1.MoveWindow(rcDlgs);  
  m_OptionsRoot2.MoveWindow(rcDlgs);  

  m_bDlgCreated = true;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void COptionsTreeDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void COptionsTreeDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR COptionsTreeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

/////////////////////////////////////////////////////////////////////////////

void COptionsTreeDlg::OnSelchangingTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

  if(m_bDlgCreated)
  {
    HTREEITEM hCurrent = m_Tree.GetSelectedItem();
    if(hCurrent)
      ((CPropertyPage*)m_Tree.GetItemData(hCurrent))->ShowWindow(SW_HIDE);
  }

	*pResult = 0;
}

/////////////////////////////////////////////////////////////////////////////

void COptionsTreeDlg::OnSelchangedTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

  if(m_bDlgCreated)
  {
    HTREEITEM hCurrent = m_Tree.GetSelectedItem();
    if(hCurrent)
      ((CPropertyPage*)m_Tree.GetItemData(hCurrent))->ShowWindow(SW_SHOW);
  }
	
	*pResult = 0;
}

/////////////////////////////////////////////////////////////////////////////
